import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { Manager, Socket as _Socket } from 'socket.io-client';
import { SocketioConfig } from './socketio.interface';
export declare class Socket implements OnDestroy {
    private socket;
    /**
     * @see {@link Socket.id}
     */
    get id(): string;
    /**
     * @see {@link Socket.connected}
     */
    get connected(): boolean;
    /**
     * @see {@link Socket.disconnected}
     */
    get disconnected(): boolean;
    /**
     * @see {@link Socket.io}
     */
    get io(): Manager;
    /**
     * @see {@link Socket.auth}
     */
    get auth(): _Socket['auth'];
    /**
     * @see {@link Socket.auth}
     */
    set auth(auth: _Socket['auth']);
    constructor({ url, options }: SocketioConfig);
    ngOnDestroy(): void;
    /**
     * @see {@link Socket.connect}
     */
    connect(): this;
    /**
     * @see {@link Socket.disconnect}
     */
    disconnect(): this;
    /**
     * @see {@link Socket.send}
     */
    send(...args: any[]): this;
    /**
     * @see {@link Socket.emit}
     */
    emit(eventName: string, ...args: any[]): this;
    /**
     * @see {@link Socket.on}
     */
    on<T>(eventName: string): Observable<T>;
    /**
     * @see {@link Socket.once}
     */
    once<T>(eventName: string): Observable<T>;
    /**
     * @see {@link Socket.compress}
     */
    compress(compress: boolean): this;
}
